//: C09:VirtualBase.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Ukazuje sdílení podobjektů pomocí virtuální základní třídy
#include <iostream>
using namespace std;

class Nejvyssi {
protected:
  int x;
public:
  Nejvyssi(int n) { x = n; }
  virtual ~Nejvyssi() {}
  friend ostream&
  operator<<(ostream& os, const Nejvyssi& t) {
    return os << t.x;
  }
};

class Leva : virtual public Nejvyssi {
protected:
  int y;
public:
  Leva(int m, int n) : Nejvyssi(m) { y = n; }
};

class Prava : virtual public Nejvyssi {
protected:
  int z;
public:
  Prava(int m, int n) : Nejvyssi(m) { z = n; }
};

class Nejnizsi : public Leva, public Prava {
  int w;
public:
  Nejnizsi(int i, int j, int k, int m)
  : Nejvyssi(i), Leva(0, j), Prava(0, k) { w = m; }
  friend ostream&
  operator<<(ostream& os, const Nejnizsi& b) {
    return os << b.x << ',' << b.y << ',' << b.z
      << ',' << b.w;
  }
};

int main() {
  Nejnizsi b(1, 2, 3, 4);
  cout << sizeof b << endl;
  cout << b << endl;
  cout << static_cast<void*>(&b) << endl;
  Nejvyssi* p = static_cast<Nejvyssi*>(&b);
  cout << *p << endl;
  cout << static_cast<void*>(p) << endl;
  cout << dynamic_cast<void*>(p) << endl;
} ///:~
